from AccessControl import ModuleSecurityInfo
from Globals import package_home
from Products.Archetypes.public import process_types, listTypes
from Products.CMFCore import utils as CMFCoreUtils
from Products.CMFCore.DirectoryView import registerDirectory
import os, os.path

# Get all the content types in the types directory
from Products.PloneHelpCenter.types import * 

from config import *

registerDirectory(SKINS_DIR, GLOBALS)

# MonkeyPatch CMFDefault.DiscussionItemContainer
import Patch

# make comment_notify importable ttw
from utils import discussion_notify
ModuleSecurityInfo('Products.PloneHelpCenter').declarePublic('discussion_notify')

def initialize(context):

    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    # Initialise. Note that the ADD_CONTENT_PERMISSION is only used in contained
    # images and files; for our special folders and content types, we have
    # defined a custom factory with either ADD_HELP_AREA_PERMISSION or
    # ADD_DOCUMENTATION_PERMISSION
    CMFCoreUtils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = content_types,
        permission         = ADD_CONTENT_PERMISSION,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)

    # Set custom permissions for all content types
    for meta_type, constructor in \
      {'HelpCenterDefinition'         : Definition.addHelpCenterDefinition,
       'HelpCenterFAQ'                : FAQ.addHelpCenterFAQ,
       'HelpCenterTutorial'           : Tutorial.addHelpCenterTutorial,
       'HelpCenterReferenceManual'    : ReferenceManual.addHelpCenterReferenceManual,
       'HelpCenterInstructionalVideo' : InstructionalVideo.addHelpCenterInstructionalVideo,
       'HelpCenterLink'               : Link.addHelpCenterLink,
       'HelpCenterHowTo'              : HowTo.addHelpCenterHowTo,
       'HelpCenterErrorReference'     : ErrorReference.addHelpCenterErrorReference
       }.items():
             
        context.registerClass(
            meta_type = meta_type,
            constructors = (constructor,),
            permission = ADD_DOCUMENTATION_PERMISSION,
            )

    for i in range(0, len(content_types)):
        if content_types[i] == HelpCenter.HelpCenter:
            constructor = constructors[i]
            context.registerClass(
                meta_type = 'HelpCenter',
                constructors = (constructor,),
                permission = ADD_HELP_AREA_PERMISSION,
                )

    # Force the loading of test data generation scripts that
    # we're currently attaching to the portal_migration tool.
    # XXX: Remove this hack when we final have a portal_test_script tool.
    import tests
