from Products.Archetypes.public import *
from Products.CMFCore import CMFCorePermissions
from AccessControl import ClassSecurityInfo, ModuleSecurityInfo
from Products.PloneHelpCenter.config import *
from schemata import ErrorReferenceSchema
from PHCContent import PHCContent

# generate the add method ourselves so we can set the add permission
security = ModuleSecurityInfo('Products.PloneHelpCenter.ErrorReference')
security.declareProtected(ADD_DOCUMENTATION_PERMISSION, 'addHelpCenterErrorReference')
def addHelpCenterErrorReference(self, id, **kwargs):
    o = HelpCenterErrorReference(id)
    self._setObject(id, o)
    o = getattr(self, id)
    o.initializeArchetype(**kwargs)

class HelpCenterErrorReference(PHCContent,OrderedBaseFolder):
    """This is an error reference object, meant to hold documentation about error messages""" 

    __implements__ = (PHCContent.__implements__,
                      OrderedBaseFolder.__implements__,)


    content_icon = 'errorref_icon.gif'

    schema = ErrorReferenceSchema
    archetype_name = 'Error Reference'
    meta_type = 'HelpCenterErrorReference'
    global_allow = 0
    filter_content_types = 1
    allow_discussion = IS_DISCUSSABLE
    allowed_content_types = ('Image', 'File', 'PloneImage', 'PloneFile', )

    typeDescription= 'An Error Reference can be used to explain a particular error which may arise.'
    typeDescMsgId  = 'description_edit_errorreference'


    actions = ({
            'id': 'view',
            'name': 'View',
            'action': 'string:${object_url}/errorreference_view',
            'permissions': (CMFCorePermissions.View,)
        },
        {
            'id': 'attachments',
            'name': 'Attachments',
            'action': 'string:${object_url}/errorreference_attachments',
            'permissions': (CMFCorePermissions.ModifyPortalContent,)
        },
        {
            'id': 'local_roles',
            'name': 'Sharing',
            'action': 'string:${object_url}/folder_localrole_form',
            'permissions': (CMFCorePermissions.ManageProperties,)
        },
    ) + PHCContent.actions

    security = ClassSecurityInfo()

registerType(HelpCenterErrorReference, PROJECTNAME)
