from Products.Archetypes.public import *
from Products.CMFCore import CMFCorePermissions
from AccessControl import ClassSecurityInfo, ModuleSecurityInfo
from Products.PloneHelpCenter.config import *
from schemata import LinkSchema
from PHCContent import PHCContent

# generate the add method ourselves so we can set the add permission
security = ModuleSecurityInfo('Products.PloneHelpCenter.Link')
security.declareProtected(ADD_DOCUMENTATION_PERMISSION, 'addHelpCenterLink')
def addHelpCenterLink(self, id, **kwargs):
    o = HelpCenterLink(id)
    self._setObject(id, o)
    o = getattr(self, id)
    o.initializeArchetype(**kwargs)

class HelpCenterLink(PHCContent,BaseContent):
    """A simple archetype"""

    __implements__ = (PHCContent.__implements__,
                      BaseContent.__implements__,)

    content_icon = 'helplink_icon.gif'

    schema = LinkSchema
    archetype_name = 'Link'
    meta_type = 'HelpCenterLink'
    global_allow = 0
    allow_discussion = IS_DISCUSSABLE

    typeDescription= 'Links are links to other documentation and resources.'
    typeDescMsgId  = 'description_edit_link'

    actions = (
        {
            'id': 'view',
            'name': 'View',
            'action': 'string:${object_url}/helplink_view',
            'permissions': (CMFCorePermissions.View,)
        },
        {
            'id': 'local_roles',
            'name': 'Sharing',
            'action': 'string:${object_url}/folder_localrole_form',
            'permissions': (CMFCorePermissions.ManageProperties,)
        },
    ) + PHCContent.actions


registerType(HelpCenterLink, PROJECTNAME)
